<form [formGroup]="applicationForm" (ngSubmit)="onSubmit(applicationForm)"
      *ngIf="applicationChanges | async as application">
    <customer [parentForm]="applicationForm"
              [customerWithContacts]="application.applicant"
              [readonly]="readonly"
              [showRepresentative]="true"
              [contactRequired]="!hasRepresentative"
              [pendingInfo]="pendingCustomerInfo$ | async"></customer>

    <customer *ngIf="hasRepresentative"
              [parentForm]="applicationForm"
              [customerWithContacts]="application.representative"
              roleType="REPRESENTATIVE"
              [readonly]="readonly"></customer>

  <div fxLayout="row">
    <div fxFlex>
      <allu-card>
        <mat-card-title>{{'application.event.title' | translation}}</mat-card-title>
        <mat-card-content>
          <div fxLayout="row wrap" fxLayoutGap="18px">
            <div fxFlex="calc(50% - 18px)">
              <mat-form-field class="input-full-width">
                <input matInput type="text" formControlName="name" required
                       [placeholder]="'application.event.name' | translation"/>
                <mat-hint>
                  <field-error [form]="applicationForm" field="name" hasError="required">
                    {{'application.field.nameMissing' | translation}}
                  </field-error>
                  <field-error [form]="applicationForm" field="name" hasError="minlength">
                    {{'application.field.nameShort' | translation}}
                  </field-error>
                </mat-hint>
              </mat-form-field>
            </div>
            <ng-container formGroupName="eventTimes">
              <div fxFlex="calc(25% - 18px)">
                <mat-form-field class="input-full-width">
                  <input matInput type="text" formControlName="startTime" required
                         [placeholder]="'application.event.startTime' | translation"
                         [matDatepicker]="startTimePicker"
                         [max]="maxEventStartTime"/>
                  <mat-datepicker-toggle matSuffix [for]="startTimePicker"
                                         [disabled]="readonly"></mat-datepicker-toggle>
                  <mat-datepicker #startTimePicker></mat-datepicker>
                  <mat-hint>
                    <field-error [form]="applicationForm.get('eventTimes')" field="startTime" hasError="required">
                      {{'application.event.field.eventStartTimeMissing' | translation}}
                    </field-error>
                    <field-error [form]="applicationForm" field="eventTimes" hasError="startBeforeEnd">
                      {{'application.event.field.startBeforeEnd' | translation}}
                    </field-error>
                  </mat-hint>
                </mat-form-field>
              </div>
              <div fxFlex="calc(25% - 18px)">
                <mat-form-field class="input-full-width">
                  <input matInput type="text" formControlName="endTime" required
                         [placeholder]="'application.event.endTime' | translation"
                         [matDatepicker]="endTimePicker"
                         [min]="minEventEndTime"/>
                  <mat-datepicker-toggle matSuffix [for]="endTimePicker" [disabled]="readonly"></mat-datepicker-toggle>
                  <mat-datepicker #endTimePicker></mat-datepicker>
                  <mat-hint>
                    <field-error [form]="applicationForm.get('eventTimes')" field="endTime" hasError="required">
                      {{'application.event.field.eventEndTimeMissing' | translation}}
                    </field-error>
                  </mat-hint>
                </mat-form-field>
              </div>
            </ng-container>
            <div fxFlex="calc(100% - 18px)">
              <mat-form-field class="input-full-width">
                <textarea matInput matTextareaAutosize formControlName="description"
                          [required]="required(applicationForm.get('description'))"
                          [placeholder]="'application.event.description' | translation"></textarea>
                <mat-hint>
                  <field-error [form]="applicationForm" field="description" hasError="required">
                    {{'application.event.field.descriptionMissing' | translation}}
                  </field-error>
                </mat-hint>
              </mat-form-field>
            </div>
            <div fxFlex="calc(100% - 18px)">
              <mat-form-field class="input-full-width">
                <textarea matInput matTextareaAutosize formControlName="timeExceptions"
                          [placeholder]="'application.event.timeExceptions' | translation"></textarea>
              </mat-form-field>
            </div>
            <div fxFlex="calc(50% - 18px)">
              <mat-form-field class="input-full-width">
                <input matInput type="text" formControlName="url"
                       [placeholder]="'application.event.url' | translation"/>
              </mat-form-field>
            </div>
            <div fxFlex="calc(25% - 18px)">
              <mat-form-field class="input-full-width">
                <input matInput type="number" formControlName="attendees"
                       step="1" min="0" [placeholder]="'application.event.attendees' | translation"/>
                <mat-hint>
                  <field-error [form]="applicationForm" field="attendees" hasError="greaterThanOrEqual">
                    {{'application.event.field.attendeesGreaterThanOrEqual' | translation}}
                  </field-error>
                </mat-hint>
              </mat-form-field>
            </div>
            <div fxFlex="calc(25% - 18px)">
              <mat-form-field class="input-full-width">
                <input matInput type="number" formControlName="entryFee"
                       step="any" min="0" [placeholder]="'application.event.entryFee' | translation"/>
                <mat-hint>
                  <field-error [form]="applicationForm" field="entryFee" hasError="greaterThanOrEqual">
                    {{'application.event.field.eventEntryFeeThanOrEqual' | translation}}
                  </field-error>
                </mat-hint>
              </mat-form-field>
            </div>
          </div>
        </mat-card-content>
      </allu-card>
    </div>
  </div>

  <div fxLayout="row">
    <div fxFlex>
      <allu-card>
        <mat-card-title>{{'application.event.structures' | translation}}</mat-card-title>
        <mat-card-content>
          <div fxLayout="row wrap" fxLayoutGap="18px">
            <div fxFlex="0 0 calc(25% - 18px)">
              <mat-checkbox #structureArea [disabled]="readonly"
                            class="input-field-checkbox"
                            [checked]="applicationForm.get('structureArea').value">
                {{'application.event.hasStructures' | translation}}
              </mat-checkbox>
            </div>
            <div fxFlex="0 0 calc(25% - 18px)" [hidden]="!structureArea.checked">
              <mat-form-field class="input-full-width">
                <input matInput type="number" formControlName="structureArea" step="any" min="0"
                       [placeholder]="'application.event.structureArea' | translation"/>
                <mat-hint>
                  <field-error [form]="applicationForm" field="structureArea" hasError="greaterThanOrEqual">
                    {{'application.event.field.structureAreaGreaterThanOrEqual' | translation}}
                  </field-error>
                </mat-hint>
              </mat-form-field>
            </div>
            <div fxFlex="calc(100% - 18px)" [hidden]="!structureArea.checked">
              <mat-form-field class="input-full-width">
                <textarea matInput matTextareaAutosize formControlName="structureDescription"
                          [placeholder]="'application.event.structureDescription' | translation"></textarea>
              </mat-form-field>
            </div>
          </div>
          <div fxLayout="row wrap" fxLayoutGap="18px">
            <div fxFlex="0 0 calc(25% - 18px)">
              <mat-checkbox #structureTimes [disabled]="readonly" class="input-field-checkbox"
                            [checked]="applicationForm.get('structureTimes.startTime').value || applicationForm.get('structureTimes.endTime').value"
                            (change)="onStructureTimeRequiredChanged()">
                {{'application.event.structureTimeRequired' | translation}}
              </mat-checkbox>
            </div>

            <ng-container formGroupName="structureTimes" *ngIf="structureTimes.checked">
              <div fxFlex="0 0 calc(25% - 18px)">
                <mat-form-field class="input-full-width">
                  <input matInput type="text" formControlName="startTime"
                         [placeholder]="'application.event.structureStartTime' | translation"
                         [matDatepicker]="structureStartTimePicker"
                         [max]="maxBuildStart"/>
                  <mat-datepicker-toggle matSuffix [for]="structureStartTimePicker"
                                         [disabled]="readonly"></mat-datepicker-toggle>
                  <mat-datepicker #structureStartTimePicker></mat-datepicker>
                  <mat-hint>
                    <field-error [form]="applicationForm" field="structureTimes" hasError="startBeforeEnd">
                      {{'application.event.field.startBeforeEnd' | translation}}
                    </field-error>
                  </mat-hint>
                  <mat-error *ngIf="applicationForm.get('structureTimes.startTime').hasError('before')">
                    {{'application.event.field.buildBeforeEventStart' | translation}}
                  </mat-error>
                </mat-form-field>
              </div>
              <div fxFlex="0 0 calc(25% - 18px)">
                <mat-form-field class="input-full-width">
                  <input matInput type="text" formControlName="endTime"
                         [placeholder]="'application.event.structureEndTime' | translation"
                         [matDatepicker]="structureEndTimePicker"
                         [min]="minTeardownEnd"/>
                  <mat-datepicker-toggle matSuffix [for]="structureEndTimePicker"
                                         [disabled]="readonly"></mat-datepicker-toggle>
                  <mat-datepicker #structureEndTimePicker></mat-datepicker>
                  <mat-error *ngIf="applicationForm.get('structureTimes.endTime').hasError('after')">
                    {{'application.event.field.teardownAfterEventEnd' | translation}}
                  </mat-error>
                </mat-form-field>
              </div>
            </ng-container>
          </div>
        </mat-card-content>
      </allu-card>
    </div>
  </div>

  <div fxLayout="row">
    <div fxFlex>
      <pricing-info [form]="applicationForm" [application]="application"></pricing-info>
    </div>
  </div>

  <div fxLayout="row" *ngIf="readonly">
    <div fxFlex>
      <location-details [application]="application" [readonly]="readonly"></location-details>
    </div>
  </div>

  <div fxLayout="row">
    <div fxFlex>
      <allu-card>
        <mat-card-title>{{'application.event.marketingProvidersTitle' | translation}}</mat-card-title>
        <mat-card-content>
          <div fxLayout="row wrap" fxLayoutGap="18px">
            <div fxFlex="calc(100% - 18px)">
              <mat-checkbox #marketingProviders [disabled]="readonly" class="input-field-checkbox"
                            [checked]="applicationForm.get('marketingProviders').value">
                {{'application.event.hasMarketingProviders' | translation}}
              </mat-checkbox>
            </div>
            <div fxFlex="calc(100% - 18px)" [hidden]="!marketingProviders.checked">
              <mat-form-field class="input-full-width">
                <textarea matInput matTextareaAutosize formControlName="marketingProviders"
                          [placeholder]="'application.event.marketingProvidersDescription' | translation"
                          ></textarea>
              </mat-form-field>
            </div>
            <div fxFlex="calc(100% - 18px)" class="input-field-checkbox">
              <mat-checkbox #foodSales formControlName="foodSales">
                {{'application.event.hasFoodSales' | translation}}
              </mat-checkbox>
            </div>
            <div fxFlex="calc(100% - 18px)" [hidden]="!foodSales.checked">
              <mat-form-field class="input-full-width">
                <textarea matInput matTextareaAutosize formControlName="foodProviders"
                          [placeholder]="'application.event.foodProviders' | translation"></textarea>
              </mat-form-field>
            </div>
          </div>
        </mat-card-content>
      </allu-card>
    </div>
  </div>

  <div fxLayout="row" *ngIf="showTerms">
    <div fxFlex>
      <allu-card>
        <mat-card-title>{{'TERMS.title' | translation}}</mat-card-title>
        <mat-card-content>
          <default-text formControlName="terms"
                        [applicationType]="application.type"
                        [readonly]="readonly"
                        [textType]="'TERMS'"
                        [includeTypes]="['TERMS']"></default-text>
        </mat-card-content>
      </allu-card>
    </div>
  </div>

  <div fxLayout="row">
    <div fxFlex>
      <distribution
        [form]="applicationForm"
        [application]="application"
        [distributionList]="distribution$ | async"
        [readonly]="readonly"
        (distributionChange)="saveDistribution($event)"></distribution>
    </div>
  </div>

  <div fxLayout="row">
    <div fxFlex>
      <application-actions
        [readonly]="readonly"
        [valid]="applicationForm.valid"
        [informationRequest]="informationRequest$ | async"
        [pendingClientData]="pendingClientData$ | async"
        [pendingInformationRequestResponse]="pendingInformationRequestResponse$ | async"
        [submitPending]="submitPending"></application-actions>
    </div>
  </div>
</form>
